<template>
<div class="wrapper wrapper-content">
    <div class="row animated fadeInRight">
        <div class="col-md-5">
            <div class="ibox float-e-margins">
                <div class="ibox-title">
                    <h5>Equipment Detail</h5>
                    <div class="ibox-tools" v-if="!loading">
                        <a class="btn btn-primary btn-xs" @click="modal_show()">
                            Edit Equipment
                        </a>
                        <a @click="get_details()">
                            <i class="fa fa-refresh"></i>
                        </a>
                    </div>
                </div>
                <div>
                    <div class="ibox-content">
                        <table class="table">
                            <tbody v-if="loading">
                                <tr>
                                    <td colspan="5">
                                        <spinner></spinner>
                                    </td>
                                </tr>
                            </tbody>
                            <tbody v-else>
                                <tr>
                                    <td>Code:</td>
                                    <th width="80%">{{ equipment.code }}</th>
                                </tr>
                                <tr>
                                    <td>Description:</td>
                                    <th>{{ equipment.description }}</th>
                                </tr>
                                <tr>
                                    <td>Brand #:</td>
                                    <th>{{ equipment.brands.length }}</th>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-md-7">
            <div class="ibox float-e-margins">
                <div class="ibox-title">
                    <h5>Equipment Brands</h5>
                    <div class="ibox-tools" v-if="!loading">
                        <a class="btn btn-primary btn-xs" @click="brand_add_show()">
                            Add Brand
                        </a>
                        <a @click="get_details()">
                            <i class="fa fa-refresh"></i>
                        </a>
                    </div>
                </div>

                <div class="ibox-content" v-if="is_brand_add">
                    <div class="row">
                        <div class="form-group">
                            <label class="col-lg-2 control-label">
                                Brand: 
                            </label>
                            <div class="col-lg-6">
                                <select data-placeholder="Choose a Brand..." 
                                        class="form-control chosen-select"
                                        v-model="add_brand_id" 
                                >
                                    <option value="">Select</option>
                                    <option  v-for="brand in brands"
                                            :key="brand.id"
                                            :value="brand.id"
                                    >{{ brand.code }}
                                    </option>
                                </select>
                            </div>
                            <div class="col-lg-4"> 
                                <button class="btn btn-danger" @click="brand_add_cancel">Cancel</button>
                                <button class="btn btn-white" @click="brand_add_save">Save</button>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="ibox-content">
                    <!-- Table -->
                    <div class="table-responsive">
                        <table class="table table-stripped">
                            <thead>
                                <tr>
                                    <th class="text-left">#</th>
                                    <th>Brand</th>
                                    <th>&nbsp;</th>
                                </tr>
                            </thead>
                            <tbody v-if="loading">
                                <tr>
                                    <td colspan="5">
                                        <spinner></spinner>
                                    </td>
                                </tr>
                            </tbody>
                            <tbody  v-else-if="equipment.brands.length">
                                <tr v-for="(brand, row) in equipment.brands" 
                                            :key="brand.id" 
                                            :row="row"
                                >
                                    <td>{{ row + 1 }}</td>
                                    <td>{{ brand.code }}</td>
                                    <td class="text-right">
                                        <button class="btn btn-white btn-sm" @click="brand_delete( brand.id )"> 
                                            <i class="fa fa-trash-o"></i>&nbsp;&nbsp;Remove&nbsp;&nbsp;&nbsp;
                                        </button>
                                    </td>
                                </tr>
                            </tbody>
                            <tbody v-else>  
                                <tr>
                                    <td colspan="7" class="text-center">
                                        No Result!
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <!-- /.table-responsive -->
                </div>
            </div>
        </div>

       <equipment-modal  v-on:save="equipment_update" v-bind:modal="modal"></equipment-modal>
    </div>
</div>
</template>

<script>
import axios from 'axios'
import Modal from './Modal.vue'
import Spinner from '../../other/Spinner.vue'
import appService from '../../../app.service.js'
import { mapGetters } from 'vuex'

export default {
    computed: {
      ...mapGetters('optionListModule', [
          'brands',
        ])
    },
    data() {
        return {
            equipment: {
                code: '',
                description: '',
                brands: {}
            },
            modal: {
                is_update: true,
                pause_save: false,
                errors: '',
                data: {
                    code: '',
                    description: '',
                }
            },
            is_brand_add: false,
            add_brand_id: '',
            loading: true,
            pause_reset: false,
            new_password: false
        }
    },
    components: {
        'equipment-modal': Modal,
        'spinner': Spinner
    },
    methods: {
        get_details () {
            this.loading = true
            this.is_brand_add = false
            
            let id = this.$route.params.id
            if( !id ) {
                this.$router.push({ name: 'equipment' })
            }else{
                axios.get(`equipment/${id}`).then(response => {
                    this.equipment = response.data.equipment
                    this.loading = false  
                })
            }
        },
        modal_show() {
            this.$store.dispatch('optionListModule/update_options')

            this.modal.errors = ''
            this.modal.is_update = true
            this.modal.data = {
                code: this.equipment.code,
                description: this.equipment.description,
                equipment_type: this.equipment.equipment_type_id,
                unit_of_measure: this.equipment.unit_of_measure_id,
            }
            $('#equipment_modal').modal('show');
        },
        equipment_update( data ){
            this.loading = true

            axios.put(`/equipment/${this.equipment.id}`,  data ).then(response => {
                if(response.data.errors) {
                    this.modal.errors = response.data.errors
                }else{
                    $('#equipment_modal').modal('hide')
                    toastr.success( response.data.message, 'Updated!' )
                    this.get_details()
                }
                this.loading = false  
            })
        },
        equipment_delete( id ){
            this.loading = true

            appService.crud.delete( `/equipment/${equipment.id}` ).then(response => {
                if(response.errors) {
                    toastr.error( response.message, 'Error!' )
                }else{
                    toastr.error( response.message, 'Deleted!' )
                    this.get_details()
                }
            }) 
            this.loading = false 
        },
        brand_add_show() {
            this.is_brand_add = true
        },
        brand_add_cancel() {
            this.is_brand_add = false
        },
        brand_add_save() {
            this.loading = true
            let data = {brand: this.add_brand_id}
            appService.crud.store( `/item/equipment/${this.equipment.id}`, data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#equipment_modal').modal('hide')
                    toastr.success( response.message, 'Saved!' )
                    this.get_details()
                }
                this.modal.pause_save = false
            })
            this.loading = false  
        },
        brand_delete( brand_id ) {
            this.loading = true
            appService.crud.delete( `/item/${brand_id}` ).then(response => {
                if(response.errors) {
                    toastr.error( response.message, 'Error!' )
                }else{
                    toastr.error( response.message, 'Deleted!' )
                    this.get_details()
                }
            })
            this.loading = false  
        }
    },
    created() {
        this.$store.dispatch('optionListModule/update_options')
        this.get_details()
    }
}
</script>

